local M = {}

local oilpressureSmoother = newExponentialSmoothing(24)
local min = math.min
local max = math.max
local OilGrade = 15000
local rpmToAV = 0.104719755

local function init()
    engine = powertrain.getDevice("mainEngine")
end


function math.Clamp(val, lower, upper)
    return math.max(lower, math.min(upper, val))
end

local function updateGFX(dt)

     local oilMath1 = 200 - electrics.values.oiltemp
	 local oilMath2 = electrics.values.rpmTacho / OilGrade
	 local oilMath3 = oilMath1 * oilMath2
	 local oilMath4 = oilMath3 / 120
	 local oilMath5 = oilMath4 + 1.1
	 
	 
     electrics.values.oilpressure = oilMath5 * engine.oilVolume * (math.Clamp(electrics.values.rpmTacho, 0, engine.idleAV / rpmToAV) / (engine.idleAV/ rpmToAV))
	 electrics.values.oilpressure = oilpressureSmoother:get(electrics.values['oilpressure'])
	 
end



M.onInit = init
M.onReset = init
M.updateGFX = updateGFX

return M